VERSION 5.00
Begin VB.UserControl HookHandler 
   BackColor       =   &H00FFFFFF&
   CanGetFocus     =   0   'False
   ClientHeight    =   450
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   480
   ClipControls    =   0   'False
   DrawMode        =   11  'Not Xor Pen
   FillStyle       =   0  'Solid
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   11.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   -1  'True
      Strikethrough   =   0   'False
   EndProperty
   FontTransparent =   0   'False
   HasDC           =   0   'False
   InvisibleAtRuntime=   -1  'True
   Picture         =   "Hooks - Handling [Class].ctx":0000
   ScaleHeight     =   450
   ScaleWidth      =   480
   ToolboxBitmap   =   "Hooks - Handling [Class].ctx":030A
   Windowless      =   -1  'True
End
Attribute VB_Name = "HookHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'==================================================================
'
' Hook Handler Control
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================



' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' '
' * * * * * * * * * * * Caution * * * * * * * * * * * * '
' *                                                   * '
' *                     Hooking                       * '
' *                                                   * '
' *  CHANGES MADE TO THE FUNCTIONS CONTAINED HEREIN   * '
' *  CAN RESULT IN A GPF, PAGE FAULT.                 * '
' *  SO SAVE YOUR CHANGES, START WITH FULL COMPILE,   * '
' *  BEFORE RUNNING THIS CLASS IN THE VB IDE!         * '
' *  USING THE BREAK-, END -BUTTON OR END STATEMENT   * '
' *  COULD GPF VB                                     * '
' *                                                   * '
' *  DOING STUPID THINGS ANYWAY WILL GPF THE VB IDE!  * '
' *                                                   * '
' * * * * * * * * * * * Caution * * * * * * * * * * * * '
' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' '

'======================================================
' Declarations

Private Const ERR_BASE = 12500

Public Enum HookingErrors
  whkErrInternal = ERR_BASE
  whkErrHooked = ERR_BASE + 1
  whkErrNotHooked = ERR_BASE + 2
  whkErrHookingFailed = ERR_BASE + 3
  whkErrUnHookingFailed = ERR_BASE + 4
  whkErrUnsupportedType = ERR_BASE + 5
  whkErrCantShareHook = ERR_BASE + 6
End Enum

Public Enum HookingTypes
  whkMessageFilter = (-1)     ' WH_MSGFILTER
  whkJournalRecord = 0        ' WH_JOURNALRECORD
  whkJournalPlayBack = 1      ' WH_JOURNALPLAYBACK
  whkKeyboardStrokes = 2      ' WH_KEYBOARD
  whkMsgPoolReading = 3       ' WH_GETMESSAGE
  whkWinProcCalls = 4         ' WH_CALLWNDPROC
  whkUITraining = 5           ' WH_CBT
' whkSysMessageFilter = 6     ' WH_SYSMSGFILTER    ' Unsupported; System hooks require a custom DLL with HookProc API's
  whkMouseMessages = 7        ' WH_MOUSE
' whkHardware = 8             ' WH_HARDWARE        ' Not currently implemented in Win32
' whkOtherHookCalls = 9       ' WH_DEBUG           ' Unsupported in W9x, NT only
  whkShellNotifications = 10  ' WH_SHELL
  whkForegroundAppIdle = 11   ' WH_FOREGROUNDIDLE
  whkWinProcCallsRetVal = 12  ' WH_CALLWNDPROCRET
'#If NT4.0 or W2K
'  WH_KEYBOARD_LL = 13
'  WH_MOUSE_LL = 14
'#End If
End Enum

Private Const HC_ACTION = 0
Private Const HC_NOREMOVE = 3
'#If W2K Then
'  HSHELL_ACCESSIBILITYSTATE = 11
'    ACCESS_STICKYKEYS = &H1
'    ACCESS_FILTERKEYS = &H2
'    ACCESS_MOUSEKEYS = &H3
'#End If
'#If NT4.0 Then
'' Low level hook flags
'  LLKHF_EXTENDED = &H1
'  LLKHF_INJECTED = &H10
'  LLKHF_ALTDOWN = &H20
'  LLKHF_UP = &H80
'  LLMHF_INJECTED = &H1
'#End If

Public Enum HookingCBTCodes
  whkCBTMoveSize = 0      ' HCBT_MOVESIZE
  whkCBTMinMax = 1        ' HCBT_MINMAX
  whkCBTQueueSync = 2     ' HCBT_QS
  whkCBTCreatedWnd = 3    ' HCBT_CREATEWND
  whkCBTDestoyingWnd = 4  ' HCBT_DESTROYWND
  whkCBTActivatingWnd = 5 ' HCBT_ACTIVATE
  whkCBTClickSkipped = 6  ' HCBT_CLICKSKIPPED
  whkCBTKeySkipped = 7    ' HCBT_KEYSKIPPED
  whkCBTSysCommand = 8    ' HCBT_SYSCOMMAND
  whkCBTSetFocus = 9      ' HCBT_SETFOCUS
End Enum

Public Enum HookingJournalPlaybackCodes
  whkJPStoreNextMsg = 1        ' HC_GETNEXT
  whkJPSkipReturnNextMsg = 2   ' HC_SKIP
  whkJPMsgNotRemoved = 3       ' HC_NOREMOVE
  whkJPResumePlayback = 4      ' HC_SYSMODALON
  whkJPStopPlayback = 5        ' HC_SYSMODALOFF
End Enum

Public Enum HookingJournalRecordCodes
  whkJRCopyRemovedMsg = 0      ' HC_ACTION
  whkJPResumeRecording = 4     ' HC_SYSMODALON
  whkJPStopRecording = 5       ' HC_SYSMODALOFF
End Enum

Public Enum HookingShellCodes
  whkShellWindowCreated = 1       ' HSHELL_WINDOWCREATED
  whkShellWindowDestroyed = 2     ' HSHELL_WINDOWDESTROYED
  whkShellActivateShellWnd = 3    ' HSHELL_ACTIVATESHELLWINDOW
  whkShellWindowActivated = 4     ' HSHELL_WINDOWACTIVATED
  whkShellGetMinRect = 5          ' HSHELL_GETMINRECT
  whkShellTaskbarTitleRedraw = 6  ' HSHELL_REDRAW
  whkShellShowTaskman = 7         ' HSHELL_TASKMAN
  whkShellKeyboardChange = 8      ' HSHELL_LANGUAGE
End Enum

Public Enum HookingMessageCodes
  whkMsgDDEMGR = &H8001   ' MSGF_DDEMGR
  whkMsgDialogBox = 0     ' MSGF_DIALOGBOX
' MSGF_MESSAGEBOX = 1     ' MSGF_MESSAGEBOX   ' Not used
  whkMsgMenu = 2          ' MSGF_MENU
  whkMsgScrollbar = 5     ' MSGF_SCROLLBAR
' MSGF_NEXTWINDOW = 6     ' MSGF_NEXTWINDOW   ' Not used
' MSGF_MAX = 8            ' MSGF_MAX          ' Not used?!
' MSGF_USER = 4096        ' MSGF_USER         ' Not used?!
End Enum

Private Const PM_NOREMOVE = &H0
Private Const PM_REMOVE = &H1

' HCBT_CREATEWND parameters pointed to by lParam
Private Type CREATESTRUCT
  lpCreateParams As Long
  hInstance As Long
  hMenu As Long
  hWndParent As Long
  cy As Long
  cx As Long
  Y As Long
  X As Long
  style As Long
  lpszName As String
  lpszClass As String
  ExStyle As Long
End Type

Private Type CBT_CREATEWND
  lpcs As CREATESTRUCT
  hwndInsertAfter As Long
End Type

' HCBT_ACTIVATE structure pointed to by lParam
Private Type CBTACTIVATESTRUCT
  fMouse As Long
  hWndActive As Long
End Type

' Message Structure used in Journaling
Private Type EVENTMSG
  message As Long
  paramL As Long
  paramH As Long
  time As Long
  hWnd As Long
End Type

' Message structure used by WH_CALLWNDPROC
Private Type CWPSTRUCT
  lParam As Long
  wParam As Long
  message As Long
  hWnd As Long
End Type

' Message structure used by WH_CALLWNDPROCRET
Private Type CWPRETSTRUCT
  lResult As Long
  lParam As Long
  wParam As Long
  message As Long
  hWnd As Long
End Type

' Structure used by WH_DEBUG
Private Type DEBUGHOOKINFO
  idThread As Long
  idThreadInstaller As Long
  lParam As Long
  wParam As Long
  Code As Long
End Type

Private Type POINTAPI
  X As Long
  Y As Long
End Type

' Structure used by WH_MOUSE
Private Type MOUSEHOOKSTRUCT
  pt As POINTAPI
  hWnd As Long
  wHitTestCode As Long
  dwExtraInfo As Long
End Type

' Structure used by WH_HARDWARE
'Private Type HARDWAREHOOKSTRUCT
'  hWnd As Long
'  message As Long
'  wParam As Long
'  lParam As Long
'End Type

'#If NT4.0 Then
'' Structure used by WH_KEYBOARD_LL
'Type KBDLLHOOKSTRUCT
'    vkCode As Long
'    scanCode As Long
'    flags As Long
'    time As Long
'    dwExtraInfo As Long
'End Type
'
'' Structure used by WH_MOUSE_LL
'Private Type MSLLHOOKSTRUCT
'    pt as POINTAPI
'    mouseData As Long
'    flags As Long
'    time As Long
'    dwExtraInfo As Long
'End Type
'#End If


' Events
Public Event CallWndProc(ByVal MustProcess As Boolean, ByVal SendByCurThread As Boolean, ByVal hWndTo As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long, ByRef ConsumeMsg As Boolean)
Attribute CallWndProc.VB_Description = "This hook is called when winproc calls are made."
Public Event CallWndRetProc(ByVal MustProcess As Boolean, ByVal SendByCurThread As Boolean, ByVal hWndTo As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal ReturnValue As Long, ByRef ConsumeMsg As Boolean)
Attribute CallWndRetProc.VB_Description = "This hook allows you to examine the values a winproc returns."
Public Event CBTProc(ByVal Code As HookingCBTCodes, ByVal CodewParam As Long, ByVal CodelParam As Long, ByRef AllowOperation As Boolean)
Public Event ForegroundIdleProc(ByVal MustProcess As Boolean, ByRef ConsumeMsg As Boolean)
Attribute ForegroundIdleProc.VB_Description = "This hook is will be called when the application's foreground thread is about to become idle. "
Public Event GetMsgProc(ByVal MustProcess As Boolean, ByVal IsRemoved As Boolean, ByVal MsghWnd As Long, ByVal MsgWindowMessage As Long, ByVal MsgwParam As Long, ByVal MsglParam As Long, ByVal MsgTime As Long, ByVal MsgMouseX As Long, ByVal MsgMouseY As Long, ByRef ConsumeMsg As Boolean)
Attribute GetMsgProc.VB_Description = "This hook monitors messages posted to a message queue, extracted by GetMessage or Peekessage APIs."
Public Event JournalPlaybackProc(ByVal Code As HookingJournalPlaybackCodes, ByRef HWMsg As Long, ByRef HWParamH As Long, ByRef HWParamL As Long, ByRef HWhWndTo As Long, ByRef ReturnValue As Long)
Attribute JournalPlaybackProc.VB_Description = "This hook helps you with the playback of user actions."
Public Event JournalRecordProc(ByVal Code As HookingJournalRecordCodes, ByVal HWMsg As Long, ByVal HWParamH As Long, ByVal HWParamL As Long, ByVal HWhWndTo As Long)
Attribute JournalRecordProc.VB_Description = "This hook helps you with recording of user actions."
Public Event KeyboardProc(ByVal IsRemoved As Boolean, ByVal VKeyCode As Long, ByVal RepeatCount As Integer, ByVal ScanCode As Byte, ByVal ExtendedKey As Boolean, ByVal ContextCode As Boolean, ByVal KeyUp As Boolean, ByVal TransitionState As Boolean, ByRef ConsumeMsg As Boolean)
Public Event MessageProc(ByVal Code As HookingMessageCodes, ByVal MsghWnd As Long, ByVal MsgWindowMessage As Long, ByVal MsgwParam As Long, ByVal MsglParam As Long, ByVal MsgTime As Long, ByVal MsgMouseX As Long, ByVal MsgMouseY As Long, ByRef ConsumeMsg As Boolean)
Attribute MessageProc.VB_Description = "This hook monitors messages generated as a result of an input event in a dialog box, message box, menu, or scroll bar. "
Public Event MouseProc(ByVal IsRemoved As Boolean, ByVal MouseMsgID As Long, ByVal MouseX As Long, ByVal MouseY As Long, ByVal hWnd As Long, ByVal HitTestCode As Long, ByVal ExtraInfo As Long, ByRef ConsumeMsg As Boolean)
Attribute MouseProc.VB_Description = "This hook monitores mouse messages, even if your window doesn't have the focus."
Public Event ShellProc(ByVal Code As HookingShellCodes, ByVal CodewParam As Long, ByVal CodelParam As Long)
Attribute ShellProc.VB_Description = "This hook notifies you about useful information from the shell."


'======================================================
' Interface for hooking

Public Function HookUsage(ByVal HookType As HookingTypes)
Attribute HookUsage.VB_Description = "This method allows you to find out how many instances are sharing the same hook proc."
  HookUsage = CurHooksCount(HookType)
End Function

Public Property Get Hooked(ByVal HookType As HookingTypes) As Boolean
Attribute Hooked.VB_Description = "This property allows you to activate certain hook types. Notice that hooks can be called very often, so they reduce system performance."
Attribute Hooked.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Hooked.VB_UserMemId = 0
Attribute Hooked.VB_MemberFlags = "600"
  Hooked = CBool(GetHook(ObjPtr(Me), HookType))
End Property

Public Property Let Hooked(ByVal HookType As HookingTypes, ByVal NewValue As Boolean)
  If NewValue Then
    Call AttachHook(ObjPtr(Me), HookType)
  Else
    Call DetachHook(ObjPtr(Me), HookType)
  End If
End Property

Friend Function RH_MessageProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Boolean
  If Not UserControl.EventsFrozen Then
    Dim MSG As MSG
    Call CopyMemory(MSG, ByVal lParam, LenB(MSG))
    RaiseEvent MessageProc(nCode, MSG.hWnd, MSG.message, MSG.wParam, MSG.lParam, MSG.time, MSG.pt.X, MSG.pt.Y, RH_MessageProc)
  End If
End Function

Friend Function RH_GetMsgProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Boolean
  If Not UserControl.EventsFrozen Then
    Dim MSG As MSG
    Call CopyMemory(MSG, ByVal lParam, LenB(MSG))
    ' PM_NOREMOVE = 0
    ' PM_REMOVE = 1
    Debug.Assert nCode = HC_ACTION
    RaiseEvent GetMsgProc(nCode = HC_ACTION, wParam, MSG.hWnd, MSG.message, MSG.wParam, MSG.lParam, MSG.time, MSG.pt.X, MSG.pt.Y, RH_GetMsgProc)
  End If
End Function

Friend Function RH_CallWndProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Boolean
  If Not UserControl.EventsFrozen Then
    Dim CWPSTRUCT As CWPSTRUCT
    Call CopyMemory(CWPSTRUCT, ByVal lParam, LenB(CWPSTRUCT))
    Debug.Assert nCode = HC_ACTION
    RaiseEvent CallWndProc(nCode = HC_ACTION, wParam, CWPSTRUCT.hWnd, CWPSTRUCT.message, CWPSTRUCT.wParam, CWPSTRUCT.lParam, RH_CallWndProc)
  End If
End Function

Friend Function RH_CallWndRetProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Boolean
  If Not UserControl.EventsFrozen Then
    Dim CWPRETSTRUCT As CWPRETSTRUCT
    Call CopyMemory(CWPRETSTRUCT, ByVal lParam, LenB(CWPRETSTRUCT))
    Debug.Assert nCode = HC_ACTION
    RaiseEvent CallWndRetProc((nCode = HC_ACTION), wParam, CWPRETSTRUCT.hWnd, CWPRETSTRUCT.message, CWPRETSTRUCT.wParam, CWPRETSTRUCT.lParam, CWPRETSTRUCT.lResult, RH_CallWndRetProc)
  End If
End Function

Friend Function RH_MouseProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Boolean
  If Not UserControl.EventsFrozen Then
    Dim MOUSEHOOKSTRUCT As MOUSEHOOKSTRUCT
    Call CopyMemory(MOUSEHOOKSTRUCT, ByVal lParam, LenB(MOUSEHOOKSTRUCT))
    RaiseEvent MouseProc((nCode And HC_NOREMOVE) = 0, wParam, MOUSEHOOKSTRUCT.pt.X, MOUSEHOOKSTRUCT.pt.Y, MOUSEHOOKSTRUCT.hWnd, MOUSEHOOKSTRUCT.wHitTestCode, MOUSEHOOKSTRUCT.dwExtraInfo, RH_MouseProc)
  End If
End Function

Friend Function RH_KeyboardProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Boolean
  If Not UserControl.EventsFrozen Then
'                                    ' BYTES:       HI----------------------------LO
'  RepeatCount Mask = &HFFFF&        ' bytes  0-15: 00000000000000001111111111111111
'  ScanCode Mask = &HFF0000          ' bytes 16-23: 00000000111111110000000000000000
'  ScanCode Divisor = &H10000        ' Devide the bits got from the scan code mask to get the real values.
'  ExtendedKey Mask = &H1000000      ' byte     24: 00000001000000000000000000000000
'  Reserved Mask = &H1E000000        ' bytes 25-28: 00011110000000000000000000000000
'  ContextCode Mask = &H20000000     ' byte     29: 00100000000000000000000000000000
'  PreviousState Mask = &H40000000   ' byte     30: 01000000000000000000000000000000
'  TransitionState Mask = &H80000000 ' byte     31: 10000000000000000000000000000000
    RaiseEvent KeyboardProc((nCode And HC_NOREMOVE) = 0, wParam, _
       (lParam And &HFFFF&), _
       (lParam And &HFF0000) / &H10000, _
       (lParam And &H1000000), _
       (lParam And &H20000000), _
       (lParam And &H40000000), _
       (lParam And &H80000000), _
       RH_KeyboardProc)
  End If
End Function

Friend Function RH_CBTProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Boolean
  If Not UserControl.EventsFrozen Then RaiseEvent CBTProc(nCode, wParam, lParam, RH_CBTProc)
End Function

Friend Sub RH_ShellProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long)
  If Not UserControl.EventsFrozen Then RaiseEvent ShellProc(nCode, wParam, lParam)
End Sub

Friend Function RH_ForegroundIdleProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Boolean
  If Not UserControl.EventsFrozen Then RaiseEvent ForegroundIdleProc(nCode = HC_ACTION, RH_ForegroundIdleProc)
End Function

Friend Function RH_JournalPlaybackProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  If Not UserControl.EventsFrozen Then
    Dim EVENTMSG As EVENTMSG
    If nCode = whkJPStoreNextMsg Then Call CopyMemory(EVENTMSG, ByVal lParam, LenB(EVENTMSG))
    RaiseEvent JournalPlaybackProc(nCode, EVENTMSG.message, EVENTMSG.paramH, EVENTMSG.paramL, EVENTMSG.hWnd, RH_JournalPlaybackProc)
    If nCode = whkJPSkipReturnNextMsg Then Call CopyMemory(ByVal lParam, EVENTMSG, LenB(EVENTMSG))
  ' Returns: waiting time if whkJPStoreNextMsg?
  End If
End Function

Friend Sub RH_JournalRecordProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long)
  If Not UserControl.EventsFrozen Then
    Dim EVENTMSG As EVENTMSG
    If nCode = HC_ACTION Then Call CopyMemory(EVENTMSG, ByVal lParam, LenB(EVENTMSG))
    RaiseEvent JournalRecordProc(nCode, EVENTMSG.message, EVENTMSG.paramH, EVENTMSG.paramL, EVENTMSG.hWnd)
  End If
End Sub

'======================================================
' Class stuff

Public Sub AboutBox()
Attribute AboutBox.VB_Description = "Shows an about dialog."
Attribute AboutBox.VB_UserMemId = -552
Attribute AboutBox.VB_MemberFlags = "40"
  frmAbout.Show vbModal
End Sub

Private Sub UserControl_Resize()
  If Not UserControl.Ambient.UserMode Then
    UserControl.Width = UserControl.ScaleX(UserControl.Picture.Width, vbHimetric, vbTwips)
    UserControl.Height = UserControl.ScaleY(UserControl.Picture.Height, vbHimetric, vbTwips)
  End If
End Sub

Private Sub UserControl_Terminate()
  Dim I As Long
  On Error Resume Next
  For I = HOOK_FIRST_MSG To HOOK_LAST_MSG
    Me.Hooked(I) = False
  Next
End Sub
